/****************************************************************************************
VFORM est un script de contrle de formulaire

Version 0.3

Copyright (C) 2006-2007  Sylvain FATOME

This program is free software; you can redistribute it and/or modify it under the terms
of the GNU General Public License as published by the Free Software Foundation; 
either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; 
if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, 
Boston, MA  02110-1301, USA.

Contact : galawa@free.fr

Web : http://smitst.homelinux.com
****************************************************************************************/

/****************************************************************************************
						-- Utilisation du script VFORM--
						           version 0.2
	
	Dfinir un tableau (chaque paramtre doit tre spars par un ";", mais il n'y a 
	pas d'ordre impos) pour dtailler les champs.
	
	IMPORTANT : ne pas metre d'espace autour des ':'.
	
>>> Paramtres :
	
	nom:nom_du_champ						Nom du champ dans le formulaire
	
	format:format_de_saisie					Format de la saisie
	
		alpha			: Alphabtique
		alphamin		: Alphabtique (minuscules seulement)
		alphamaj		: Alphabtique (majuscules seulement)
		alphanum		: Alphanumrique
		alphanummin		: Alphanumrique (minuscules seulement)
		alphanummaj		: Alphanumrique (majuscules seulement)
		chemin			: chemin (alphanumrique + '_'), type "/xxxx/xxxx"
		cp				: Code postal (le pays dtermine le type de code postal)
		cp_fr			: Code postal Franais
		cp_us			: Code postal Amricain
		date			: Date
			masques possibles :
				mmddyy		mmddyyyy	mm/dd/yy	mm/dd/yyyy
				jjmmaa		jjmmaaaa	jj/mm/aa	jj/mm/aaaa
				mm-dd-yy	mm-dd-yyyy	jj-mm-aa	jj-mm-aaaa

		duree			: Dure (format hh:mm:ss), pas de contrle sur les heures
		dureehhmm		: Dure (format hh:mm), pas de contrle sur les heures
		entier			: Entier sign
		extens			: extension de fichier (type ".xxx")
		heure			: Heure (format hh:mm:ss)
		heurehhmm		: Heure (format hh:mm)
		hexa			: Hexadcimal
		nf_fr			: Numro fiscal Franais
		ip				: Adresse IP
		mac				: Adresse MAC (xx:xx:xx:xx:xx:xx ou xx-xx-xx-xx-xx-xx)
		mail			: Email
		pw				: Mot de passe
						il faut aussi donner le niveau de "qualit" minimum (de 0  9) avec la variable pwq
		reel			: Rel sign
		reel_ns			: Rel non sign
		rib_fr			: Relev d'Identit Bancaire Franais
		secu			: Numro de SECURITE SOCIALE (le pays dtermine le type de numro)
		secu_fr			: Numro de SECURITE SOCIALE Franaise
		secu_us			: Numro de SECURITE SOCIALE aux USA
		siren_fr		: Numro de SIREN
		siret_fr		: Numro de SIRET
		naf_fr			: Numro de NAF
		tva_fr			: Numro de TVA (FR)
		tel				: Numro de tlphone (le pays dtermine le type de numro)
		tel_fr			: Numro de tlphone franais
							xxxxxxxxxx ou +33 xxxxxxxxx
						ou 
							xx xx xx xx xx ou +33 x xx xx xx xx
						ou 
							xx-xx-xx-xx-xx ou +33 x-xx-xx-xx-xx
						ou 
							xx.xx.xx.xx.xx ou +33 x.xx.xx.xx.xx
						

		telp			: Numro de tlphone portable (le pays dtermine le type de numro)
		telp_fr			: Numro de tlphone portable franais
							06xxxxxxxx ou +33 6xxxxxxxx
						ou 
							06 xx xx xx xx ou +33 6 xx xx xx xx
						ou 
							06-xx-xx-xx-xx ou +33 6-xx-xx-xx-xx
						ou 
							06.xx.xx.xx.xx ou +33 6.xx.xx.xx.xx
						
		txt				: Tout type de texte
		unsigned		: Entier non sign
		url_pref		: url (avec prfixe http, https, ftp, sftp, ftps, gopher, telnet)
			Conforme  la norme xxxx://log:mdp@xxx.xxxxxx.xxx:1234/xxxx?xxx=123&xxx=123
			Accepte aussi les adresse IP au lieu des noms de domaines
		url_npref				: url (sans prfixe)
			Conforme  la norme log:mdp@xxx.xxxxxx.xxx:1234/xxxx?xxx=123&xxx=123
			Accepte aussi les adresse IP au lieu des noms de domaines


	req:Y ou y ou O ou o					Champ requis ?
		(si rien, pas requis)

	lmn										Longueur minimum
		(Entier non sign. si rien : 0)
		Pour les listes multiples	: nb minimum de lignes  choisir

	lmx										Longueur maximum
		(Entier non sign)
		Pour les listes multiples	: nb maximum de lignes  choisir

	vmn										Valeur minimum
		(Entier non sign)

		Pour les listes     : n minimum de la 1re ligne
		Pour les " cocher" : n minimum de la 1re case ou du 1er bouton
		Pour les dates		: date minimum
		Pour les valeurs	: valeur minimum

	vmx										Valeur maximum
		(Entier non sign)

		Pour les listes     : n maximum de la dernire ligne slectionnable
		Pour les " cocher" : n minimum de la dernire case ou du dernier bouton
		Pour les dates		: date maximum
		Pour les valeurs	: valeur maximum
		
				
	masque								dfinition du masque de saisie
		(Pour les dates. OBLIGATOIRE dans ce cas)

	stok								Style si champ ok
		(Si rien, on n'y touche pas)

	stbad								Style si champ pas ok
		(Si rien, on n'y touche pas)

	txt									Texte descriptif du champ pour popup erreur
		(Si rien, le script fabrique une chane avec le nom du champ)

	comp								Champ  comparer (dtection de champs identiques)
		On y entre le nom du champ qui doit tre compar
		
		Pour les textes : comparaison des 2 saisies
		Pour les boutons et cases  cocher : comparaison des structures et 
			cases/boutons cochs
		Pour les listes simples : comparaison des structures et de la ligne choisie
		Pour les listes multiples : comparaison des structures et de la (des) 
			ligne(s) choisie(s)
			
	carenum								Caractre d'numration
		Sur la base du format de champ dfini, on peut demander une numration
		avec un caractre de sparation.
		Chaque saisie entre ce caractre est alors analyse sur le format dfini (avec les
		critres qui s'appliquent alors  cette saisie) pour vrifier que c'est ok.

		Par exemple, si vous dfinissez une numration d'extensions de fichier, sur une 
		longueur minimale de 3 caractres, et maximale de 4, et un sparateur ',', VForm va 
		analyser chaque saisie entre les ',' pour vrifier que c'est bien une extension (".xxx"),
		avec une longueur minimale de 3 caractres, et maximale de 4 caractres.

		On peut tout mettre, sauf ';'.


	La fonction s'appelle par :
	
				VForm(nom_du_formulaire,tableau_de_dfinition,pays,langage)
				
	Nota :
		Si pas de pays dfini, Frane ('fr') par dfaut
		Si pas de langage dfini, Franais ('fr') par dfaut
****************************************************************************************/

// Suppression des espaces en dbut en fin de chane
function RLtrim(texte)
{	
	return texte.replace(/(^\s*)|(\s*$)/g,"");
}

// Convertion caractre accentus en octal
function ConvertAccents(texte)
{
	var texte_ok = '';
	
	for (var i=0; i<texte.length; i++)
	{
		switch(texte.charAt(i))
		{
			case '':
				texte_ok=texte_ok+'\242';
				break;
			case '':
				texte_ok=texte_ok+'\243';
				break;
			case '':
				texte_ok=texte_ok+'\245';
				break;
			case '':
				texte_ok=texte_ok+'\274';
				break;
			case '':
				texte_ok=texte_ok+'\275';
				break;
			case '':
				texte_ok=texte_ok+'\276';
				break;
			case '':
				texte_ok=texte_ok+'\241';
				break;
			case '':
				texte_ok=texte_ok+'\253';
				break;
			case '':
				texte_ok=texte_ok+'\273';
				break;
			case '':
				texte_ok=texte_ok+'\277';
				break;
			case '':
				texte_ok=texte_ok+'\300';
				break;
			case '':
				texte_ok=texte_ok+'\301';
				break;
			case '':
				texte_ok=texte_ok+'\302';
				break;
			case '':
				texte_ok=texte_ok+'\303';
				break;
			case '':
				texte_ok=texte_ok+'\304';
				break;
			case '':
				texte_ok=texte_ok+'\305';
				break;
			case '':
				texte_ok=texte_ok+'\306';
				break;
			case '':
				texte_ok=texte_ok+'\307';
				break;
			case '':
				texte_ok=texte_ok+'\310';
				break;
			case '':
				texte_ok=texte_ok+'\311';
				break;
			case '':
				texte_ok=texte_ok+'\312';
				break;
			case '':
				texte_ok=texte_ok+'\313';
				break;
			case '':
				texte_ok=texte_ok+'\314';
				break;
			case '':
				texte_ok=texte_ok+'\315';
				break;
			case '':
				texte_ok=texte_ok+'\316';
				break;
			case '':
				texte_ok=texte_ok+'\317';
				break;
			case '':
				texte_ok=texte_ok+'\313';
				break;
			case '':
				texte_ok=texte_ok+'\320';
				break;
			case '':
				texte_ok=texte_ok+'\321';
				break;
			case '':
				texte_ok=texte_ok+'\313';
				break;
			case '':
				texte_ok=texte_ok+'\322';
				break;
			case '':
				texte_ok=texte_ok+'\323';
				break;
			case '':
				texte_ok=texte_ok+'\324';
				break;
			case '':
				texte_ok=texte_ok+'\325';
				break;
			case '':
				texte_ok=texte_ok+'\326';
				break;
			case '':
				texte_ok=texte_ok+'\330';
				break;
			case '':
				texte_ok=texte_ok+'\331';
				break;
			case '':
				texte_ok=texte_ok+'\332';
				break;
			case '':
				texte_ok=texte_ok+'\333';
				break;
			case '':
				texte_ok=texte_ok+'\334';
				break;
			case '':
				texte_ok=texte_ok+'\335';
				break;
			case '':
				texte_ok=texte_ok+'\336';
				break;
			case '':
				texte_ok=texte_ok+'\337';
				break;
			case '':
				texte_ok=texte_ok+'\340';
				break;
			case '':
				texte_ok=texte_ok+'\341';
				break;
			case '':
				texte_ok=texte_ok+'\342';
				break;
			case '':
				texte_ok=texte_ok+'\343';
				break;
			case '':
				texte_ok=texte_ok+'\344';
				break;
			case '':
				texte_ok=texte_ok+'\345';
				break;
			case '':
				texte_ok=texte_ok+'\346';
				break;
			case '':
				texte_ok=texte_ok+'\347';
				break;
			case '':
				texte_ok=texte_ok+'\350';
				break;
			case '':
				texte_ok=texte_ok+'\351';
				break;
			case '':
				texte_ok=texte_ok+'\352';
				break;
			case '':
				texte_ok=texte_ok+'\353';
				break;
			case '':
				texte_ok=texte_ok+'\354';
				break;
			case '':
				texte_ok=texte_ok+'\355';
				break;
			case '':
				texte_ok=texte_ok+'\356';
				break;
			case '':
				texte_ok=texte_ok+'\357';
				break;
			case '':
				texte_ok=texte_ok+'\360';
				break;
			case '':
				texte_ok=texte_ok+'\361';
				break;
			case '':
				texte_ok=texte_ok+'\362';
				break;
			case '':
				texte_ok=texte_ok+'\363';
				break;
			case '':
				texte_ok=texte_ok+'\364';
				break;
			case '':
				texte_ok=texte_ok+'\365';
				break;
			case '':
				texte_ok=texte_ok+'\366';
				break;
			case '':
				texte_ok=texte_ok+'\370';
				break;
			case '':
				texte_ok=texte_ok+'\371';
				break;
			case '':
				texte_ok=texte_ok+'\372';
				break;
			case '':
				texte_ok=texte_ok+'\373';
				break;
			case '':
				texte_ok=texte_ok+'\374';
				break;
			case '':
				texte_ok=texte_ok+'\375';
				break;
			case '':
				texte_ok=texte_ok+'\376';
				break;
			case '':
				texte_ok=texte_ok+'\377';
				break;
			default:
				texte_ok=texte_ok+texte.charAt(i);
				break;
		}
	}
	
	return texte_ok;
}

// Vrifie si une valeur est bien dans une fourchette
function ValInMinMax(valeur,mini,maxi)
{
	// On vrifie que min et maxi sont dfinis. Si oui, on vrifie que mini <= Maxi
	if ((!isNaN(mini)) && (!isNaN(maxi)))
		if (mini>maxi)
			return false;
	// On vrifie que mini est dfini. Si oui, on teste
	if (!isNaN(mini))
		if (valeur<mini)
			return false;
	// On vrifie que maxi est dfini. Si oui, on teste
	if (!isNaN(maxi))
		if (valeur>maxi)
			return false;

	return true;
}

// Vrifie si la chane est au format hexadcimal
function IsHexa(str)
{	
	var expr = new RegExp("^[a-f0-9]+$","gi");
	if ( !expr.test(str) )
		return false;

	return true;
}

// Vrifie si la chane est au format entier non sign
function IsUnsigned(str)
{	
	var expr = new RegExp("^[0-9]*$","gi");
	if ( !expr.test(str) )
		return false;

	return true;
}

// Vrifie si la chane est au format entier sign
function IsInteger(str)
{	
	var expr = new RegExp("^[\+\-]?[0-9]*$","gi");
	if ( !expr.test(str) )
		return false;

	return true;
}

// Vrifie si la chane est au format rel sign
function IsReal(str)
{	
	var expr = new RegExp("^[\+\-]?[0-9]+(\.[0-9]{0,})?$","gi");
	if ( !expr.test(str) )
		return false;

	return true;
}

// Vrifie si la chane est au format rel non sign
function IsRealUnsigned(str)
{	
	var expr = new RegExp("^[0-9]+(\.[0-9]{0,})?$","gi");
	if ( !expr.test(str) )
		return false;

	return true;
}

// Vrifie une date
function IsDate(date,masque)
{	
	if (!date)
		return false;

	var jour,mois,annee;
	switch (masque)
	{
		case "mmddyy":
			var expr = new RegExp("^[0-9]{6}$");
			// On vrifie le format
			if (!expr.test(date))
			{
				return false;
			}
			else
			{
				mois=Number(date.substr(0,2));
				jour=Number(date.substr(2,2));
				annee=Number(date.substr(4,2))+2000;
			}
			break;
		case "mmddyyyy":
			var expr = new RegExp("^[0-9]{8}$");
			// On vrifie le format
			if (!expr.test(date))
			{
				return false;
			}
			else
			{
				mois=Number(date.substr(0,2));
				jour=Number(date.substr(2,2));
				annee=Number(date.substr(4,4));
			}
			break;
		case "jjmmaa":
			var expr = new RegExp("^[0-9]{6}$");
			if (!expr.test(date))
			{
				return false;
			}
			else
			{
				jour=Number(date.substr(0,2));
				mois=Number(date.substr(2,2));
				annee=Number(date.substr(4,2))+2000;
			}
			break;
		case "jjmmaaaa":
			var expr = new RegExp("^[0-9]{8}$");
			if (!expr.test(date))
			{
				return false;
			}
			else
			{
				jour=Number(date.substr(0,2));
				mois=Number(date.substr(2,2));
				annee=Number(date.substr(4,4));
			}
			break;
		case "mm-dd-yy":
			var expr = new RegExp("^[0-9]{2}\-[0-9]{2}\-[0-9]{2}$");
			// On vrifie le format
			if (!expr.test(date))
			{
				return false;
			}
			else
			{
				var tab_date = date.split("-");
				mois=Number(tab_date[0]);
				jour=Number(tab_date[1]);
				annee=Number(tab_date[2])+2000;
			}
			break;
		case "mm/dd/yy":
			var expr = new RegExp("^[0-9]{2}\/[0-9]{2}\/[0-9]{2}$");
			// On vrifie le format
			if (!expr.test(date))
			{
				return false;
			}
			else
			{
				var tab_date = date.split("/");
				mois=Number(tab_date[0]);
				jour=Number(tab_date[1]);
				annee=Number(tab_date[2])+2000;
			}
			break;
		case "mm-dd-yyyy":
			var expr = new RegExp("^[0-9]{2}\-[0-9]{2}\-[0-9]{4}$");
			// On vrifie le format
			if (!expr.test(date))
			{
				return false;
			}
			else
			{
				var tab_date = date.split("-");
				mois=Number(tab_date[0]);
				jour=Number(tab_date[1]);
				annee=Number(tab_date[2]);
			}
			break;
		case "mm/dd/yyyy":
			var expr = new RegExp("^[0-9]{2}\/[0-9]{2}\/[0-9]{4}$");
			// On vrifie le format
			if (!expr.test(date))
			{
				return false;
			}
			else
			{
				var tab_date = date.split("/");
				mois=Number(tab_date[0]);
				jour=Number(tab_date[1]);
				annee=Number(tab_date[2]);
			}
			break;
		case "jj-mm-aa":
			var expr = new RegExp("^[0-9]{2}\-[0-9]{2}\-[0-9]{2}$");
			if (!expr.test(date))
			{
				return false;
			}
			else
			{
				var tab_date = date.split("-");
				jour=Number(tab_date[0]);
				mois=Number(tab_date[1]);
				annee=Number(tab_date[2])+2000;
			}
			break;
		case "jj/mm/aa":
			var expr = new RegExp("^[0-9]{2}\/[0-9]{2}\/[0-9]{2}$");
			if (!expr.test(date))
			{
				return false;
			}
			else
			{
				var tab_date = date.split("/");
				jour=Number(tab_date[0]);
				mois=Number(tab_date[1]);
				annee=Number(tab_date[2])+2000;
			}
			break;
		case "jj-mm-aaaa":
			var expr = new RegExp("^[0-9]{2}\-[0-9]{2}\-[0-9]{4}$");
			if (!expr.test(date))
			{
				return false;
			}
			else
			{
				var tab_date = date.split("-");
				jour=Number(tab_date[0]);
				mois=Number(tab_date[1]);
				annee=Number(tab_date[2]);
			}
			break;
		case "jj/mm/aaaa":
			var expr = new RegExp("^[0-9]{2}\/[0-9]{2}\/[0-9]{4}$");
			if (!expr.test(date))
			{
				return false;
			}
			else
			{
				var tab_date = date.split("/");
				jour=Number(tab_date[0]);
				mois=Number(tab_date[1]);
				annee=Number(tab_date[2]);
			}
			break;
		default :
			return false;
			break;
	}
	// On contrle la validit du jour
	if ((jour==0) || (jour>31))
	{
		return false;
	}
	else
	{
		// vrification du nombre de jour dans le mois
		var dt_test = new Date(annee, Number(mois-1), jour);
		if (dt_test.getMonth() != Number(mois-1))
			return false;
	}

	// On contrle la validit du mois
	if ((mois==0) || (mois>12))
	{
		return false;
	}
	
	return true;
}

// Vrifie si une date est bien dans une fourchette
function DateInMinMax(date,dmini,dmaxi,masque)
{
	if ((IsDate(date,masque)) && (IsDate(dmini,masque)) && (IsDate(dmaxi,masque)))
	{
		var jour,mois,annee,
			jourmn,moismn,anneemn,
			jourmx,moismx,anneemx;
		switch (masque)
		{
			case "mmddyy":
				mois=Number(date.substr(0,2));
				jour=Number(date.substr(2,2));
				annee=Number(date.substr(4,2))+2000;
				moismn=Number(dmini.substr(0,2));
				jourmn=Number(dmini.substr(2,2));
				anneemn=Number(dmini.substr(4,2))+2000;
				moismx=Number(dmaxi.substr(0,2));
				jourmx=Number(dmaxi.substr(2,2));
				anneemx=Number(dmaxi.substr(4,2))+2000;
				break;
			case "mmddyyyy":
				mois=Number(date.substr(0,2));
				jour=Number(date.substr(2,2));
				annee=Number(date.substr(4,4));
				moismn=Number(dmini.substr(0,2));
				jourmn=Number(dmini.substr(2,2));
				anneemn=Number(dmini.substr(4,4));
				moismx=Number(dmaxi.substr(0,2));
				jourmx=Number(dmaxi.substr(2,2));
				anneemx=Number(dmaxi.substr(4,4));
				break;
			case "jjmmaa":
				jour=Number(date.substr(0,2));
				mois=Number(date.substr(2,2));
				annee=Number(date.substr(4,2))+2000;
				moismn=Number(dmini.substr(0,2));
				jourmn=Number(dmini.substr(2,2));
				anneemn=Number(dmini.substr(4,2))+2000;
				moismx=Number(dmaxi.substr(0,2));
				jourmx=Number(dmaxi.substr(2,2));
				anneemx=Number(dmaxi.substr(4,2))+2000;
				break;
			case "jjmmaaaa":
				jour=Number(date.substr(0,2));
				mois=Number(date.substr(2,2));
				annee=Number(date.substr(4,4));
				moismn=Number(dmini.substr(0,2));
				jourmn=Number(dmini.substr(2,2));
				anneemn=Number(dmini.substr(4,4));
				moismx=Number(dmaxi.substr(0,2));
				jourmx=Number(dmaxi.substr(2,2));
				anneemx=Number(dmaxi.substr(4,4));
				break;
			case "mm-dd-yy":
			case "mm-dd-yyyy":
				var tab_date = date.split("-");
				mois=Number(tab_date[0]);
				jour=Number(tab_date[1]);
				annee=Number(tab_date[2]);
				if (annee<2000)
					annee=annee+2000;
				var tab_dmini = dmini.split("-");
				moismn=Number(tab_dmini[0]);
				jourmn=Number(tab_dmini[1]);
				anneemn=Number(tab_dmini[2]);
				if (anneemn<2000)
					anneemn=anneemn+2000;
				var tab_dmaxi = dmaxi.split("-");
				moismx=Number(tab_dmaxi[0]);
				jourmx=Number(tab_dmaxi[1]);
				anneemx=Number(tab_dmaxi[2]);
				if (anneemx<2000)
					anneemx=anneemx+2000;
				break;
			case "mm/dd/yy":
			case "mm/dd/yyyy":
				var tab_date = date.split("/");
				mois=Number(tab_date[0]);
				jour=Number(tab_date[1]);
				annee=Number(tab_date[2]);
				if (annee<2000)
					annee=annee+2000;
				var tab_dmini = dmini.split("/");
				moismn=Number(tab_dmini[0]);
				jourmn=Number(tab_dmini[1]);
				anneemn=Number(tab_dmini[2]);
				if (anneemn<2000)
					anneemn=anneemn+2000;
				var tab_dmaxi = dmaxi.split("/");
				moismx=Number(tab_dmaxi[0]);
				jourmx=Number(tab_dmaxi[1]);
				anneemx=Number(tab_dmaxi[2]);
				if (anneemx<2000)
					anneemx=anneemx+2000;
				break;
			case "jj-mm-aa":
			case "jj-mm-aaaa":
				var tab_date = date.split("-");
				jour=Number(tab_date[0]);
				mois=Number(tab_date[1]);
				annee=Number(tab_date[2]);
				if (annee<2000)
					annee=annee+2000;
				var tab_dmini = dmini.split("-");
				jourmn=Number(tab_dmini[0]);
				moismn=Number(tab_dmini[1]);
				anneemn=Number(tab_dmini[2]);
				if (anneemn<2000)
					anneemn=anneemn+2000;
				var tab_dmaxi = dmaxi.split("-");
				jourmx=Number(tab_dmaxi[0]);
				moismx=Number(tab_dmaxi[1]);
				anneemx=Number(tab_dmaxi[2]);
				if (anneemx<2000)
					anneemx=anneemx+2000;
				break;
			case "jj/mm/aa":
			case "jj/mm/aaaa":
				var tab_date = date.split("/");
				jour=Number(tab_date[0]);
				mois=Number(tab_date[1]);
				annee=Number(tab_date[2]);
				if (annee<2000)
					annee=annee+2000;
				var tab_dmini = dmini.split("/");
				jourmn=Number(tab_dmini[0]);
				moismn=Number(tab_dmini[1]);
				anneemn=Number(tab_dmini[2]);
				if (anneemn<2000)
					anneemn=anneemn+2000;
				var tab_dmaxi = dmaxi.split("/");
				jourmx=Number(tab_dmaxi[0]);
				moismx=Number(tab_dmaxi[1]);
				anneemx=Number(tab_dmaxi[2]);
				if (anneemx<2000)
					anneemx=anneemx+2000;
				break;
			default :
				return false;
				break;
		}

		var datetst = new Date(annee, Number(mois-1), jour);
		var datemn = new Date(anneemn, Number(moismn-1), jourmn);
		var datemx = new Date(anneemx, Number(moismx-1), jourmx);
		
		if (datemx.getTime()>=datemn.getTime())
		{
			if ((datetst.getTime()>=datemn.getTime()) && (datetst.getTime()<=datemx.getTime()))
			{
				return true;
			}
			else
			{
				return false;
			}
		}
		else
		{
			return false;
		}
	}
	else
	{
		return true;
	}
}

// Vrifie si la chane est au format heure hh:mm:ss
function IsHeure(str)
{	
	var expr = new RegExp("^[0-9]{1,2}\:[0-9]{1,2}\:[0-9]{1,2}$");
	if ( !expr.test(str) )
		return false;

	// On vrifie les valeurs individuelles
	var tab_duree = str.split(":");
	if ((Number(tab_duree[0]) > 23) || (Number(tab_duree[1]) > 59) || (Number(tab_duree[2]) > 59))
		return false;

	return true;
}

// Convertit une heure en secondes
function ConvertHeureSec(str)
{
	var totalsec =0;
	if (IsHeure(str)) // Si c'est vraiment une heure
	{
		// On calcule la dure totale en secondes
		var tab_duree = str.split(":");
		totalsec = (Number(tab_duree[0])*3600)+(Number(tab_duree[1])*60)+Number(tab_duree[2]);
	}

	return totalsec;
}

// Vrifie si la chane est au format heure hh:mm
function IsHeurehhmm(str)
{	
	var expr = new RegExp("^[0-9]{1,2}\:[0-9]{1,2}$");
	if ( !expr.test(str) )
		return false;

	// On vrifie les valeurs individuelles
	var tab_duree = str.split(":");
	if ((Number(tab_duree[0]) > 23) || (Number(tab_duree[1]) > 59))
		return false;

	return true;
}

// Convertit une heure hhmm en secondes
function ConvertHeurehhmmSec(str)
{
	var totalsec =0;
	if (IsHeurehhmm(str)) // Si c'est vraiment une heure hhmm
	{
		// On calcule la dure totale en secondes
		var tab_duree = str.split(":");
		totalsec = (Number(tab_duree[0])*3600)+(Number(tab_duree[1])*60);
	}

	return totalsec;
}

// Vrifie si la chane est une dure
function IsDuree(str)
{	
	var expr = new RegExp("^[0-9]{1,}\:[0-9]{1,2}\:[0-9]{1,2}$");
	if ( !expr.test(str) )
		return false;

	// On vrifie les valeurs individuelles
	var tab_duree = str.split(":");
	if ((Number(tab_duree[1]) > 59) || (Number(tab_duree[2]) > 59))
		return false;

	return true;
}

// Vrifie si la chane est une dure
function IsDureehhmm(str)
{	
	var expr = new RegExp("^[0-9]{1,}\:[0-9]{1,2}$");
	if ( !expr.test(str) )
		return false;

	// On vrifie les valeurs individuelles
	var tab_duree = str.split(":");
	if (Number(tab_duree[1]) > 59)
		return false;

	return true;
}

// Convertit une dure en secondes
function ConvertDureeSec(str)
{
	var totalsec=0;
	if (IsDuree(str)) // Si c'est vraiment une dure
	{
		// On calcule la dure totale en secondes
		var tab_duree = str.split(":");
		totalsec = (Number(tab_duree[0])*3600)+(Number(tab_duree[1])*60)+Number(tab_duree[2]);
	}

	return totalsec;
}

// Convertit une dure hhmm en secondes
function ConvertDureehhmmSec(str)
{
	var totalsec=0;
	if (IsDureehhmm(str)) // Si c'est vraiment une dure hhmm
	{
		// On calcule la dure totale en secondes
		var tab_duree = str.split(":");
		totalsec = (Number(tab_duree[0])*3600)+(Number(tab_duree[1])*60);
	}

	return totalsec;
}

// Vrifie si un texte est vide
function ChampEstVide(texte)
{
	if (!texte)
	{
		return true;
	}

	if (RLtrim(texte)=="")
	{
		return true;
	}
	
	return false;
}

// Donne le nombre d'lments slectionns dans une liste
function NbElementsSel(liste)
{
	var nbSelected=0;
	for (var nb=0; nb<liste[0].options.length; nb++)
	{
		if (liste[0].options[nb].selected)
		{
			nbSelected++;
		}
	}
	
	return nbSelected;
}

// Donne le nombre d'lments cochs dans une liste
function NbElementsChk(liste)
{
	var nbChecked=0;
	for (var nb=0; nb<liste.length; nb++)
	{
		if (liste[nb].checked)
		{
			nbChecked++;
		}
	}
	
	return nbChecked;
}

// Fonction de contrle du SIREN
function IsSiren(siren)
{
	if ((siren.length != 9) || (isNaN(siren)) )
		return false;

	var somme = 0;
	var tmp;
	for (var idx=0; idx<siren.length; idx++) 
	{
		// Les positions paires : 2me, 4me, 6me et 8me chiffre
		if ((idx % 2) == 1) 
		{ 
			tmp = siren.charAt(idx) * 2; // On le multiplie par 2
			if (tmp > 9)
				tmp -= 9;    // Si le rsultat est suprieur  9, on lui soustrait 9
		}
		else
			tmp = siren.charAt(idx);

		somme += parseInt(tmp);
	}

	// Si la somme est un multiple de 10 alors le SIREN est valide
	if ((somme % 10) == 0)
		return true; 
	else
		return false;
}

// Fonction de contrle du SIRET
function IsSiret(siret)
{
	if ( (siret.length != 14) || (isNaN(siret)) )
		return false;

	var somme = 0;
	var tmp;

	for (var idx = 0; idx<siret.length; idx++) 
	{
		// Les positions impaires : 1er, 3, 5, etc...
		if ((idx % 2) == 0) 
		{ 
			tmp = siret.charAt(idx) * 2; // On le multiplie par 2
			if (tmp > 9)
				tmp -= 9;    // Si le rsultat est suprieur  9, on lui soustrait 9
		}
		else
			tmp = siret.charAt(idx);
		somme += parseInt(tmp);
	}

	if ((somme % 10) == 0)
		return true; // Si la somme est un multiple de 10 alors le SIRET est valide
	else
		return false;
}

// Fonction de contrle du RIB
function IsRIB(rib)
{
	var tab_rib = rib.split(" ");

	var banque=tab_rib[0];
	var guichet=tab_rib[1];
	var compte=tab_rib[2];
	var clef=parseInt(tab_rib[3]);

	// Conversion du numro de compte en chiffres
	var tab= "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
	var tab1="123456789123456789234567890123456789";

	var cpte="";
	for (var idx = 0; idx<compte.length; idx++) 
	{
		cpte+=tab1.charAt(tab.indexOf(compte.charAt(idx)));
	}

	//Calcul cl RIB
	var clefc = 97 - (((parseInt(banque)% 97 * 100000 + parseFloat(guichet)) % 97 * 100000000000 + parseInt(cpte)) % 97) * 100 % 97;
	
	if (clef == clefc)
		return true; 
	else
		return false;
}

// Fonction de contrle du numro INSEE
function IsINSEE(insee)
{
	var tab_insee = insee.split(" ");
	var clef=parseInt(tab_insee[6]);

	var retirer=0;
	if (tab_insee[3]=="2A")
	{
		retirer=1000000;
		tab_insee[3]="20"
	}
	if (tab_insee[3]=="2B")
	{
		retirer=2000000;
		tab_insee[3]="20"
	}
	var tab_pnum = tab_insee.slice(0,6);
	var pnum = tab_pnum.join("");

	//Calcul cl INSEE
	var clefc = 97 - (parseInt(pnum)% 97);

	if (clef == clefc)
		return true; 
	else
		return false;
}

// Donne la qualit d'un mot de passe
function GivePwQ(valpw)
{
	var nivpw=0;	// Niveau calcul

	if ((valpw) && (valpw!=""))
	{
		// Vrification majuscules
		if (valpw.match(/[A-Z]/))
		{
			nivpw++;
		}

		// Vrification minuscules
		if (valpw.match(/[a-z]/))
		{
			nivpw++;
		}

		// Vrification si caractres numriques
		if (valpw.match(/\d/))
		{
			nivpw++;
		}

		// Vrification prsence caractre soulign
		if (valpw.indexOf("_") > -1) 
		{
			nivpw++;
		}

		// Il doit y avoir un caractre spcial
		if (valpw.match(/[\-\#\@\%\!\$\*\&\<\>]/))
		{
			nivpw++;
		}

		// Il doit y avoir une parenthse spciale
		if (valpw.match(/[\{\}\[\]]/))
		{
			nivpw++;
		}

		//  Il vaut mieux commencer avec une lettre
		if (valpw.match(/^[a-zA-Z]+/))
		{
			nivpw++;
		}
		
		// Les espaces ne sont pas recommands
		var invalide = " ";
		if (!(valpw.indexOf(invalide) > -1))
		{
			nivpw++;
		}
	}
	
	return nivpw;
}

// Valide un champ texte sur le format donn
function valide_champ(pays,valeur,format,masque,vmn,vmx,pwq)
{
	var errno=-1;

	valeur=RLtrim(valeur);
	
	// On ne teste que si le champ contient quelque chose
	if (ChampEstVide(valeur)==false)
	{
		if (format=='cp')
		{
			format='cp_'+pays;
		}
		
		if (format=='secu')
		{
			format='secu_'+pays;
		}
		
		if (format=='tel')
		{
			format='tel_'+pays;
		}
		
		if (format=='telp')
		{
			format='telp_'+pays;
		}
		
		switch (format)
		{
			// Date
			case 'date':
				if (IsDate(valeur,masque)==false)
				{
					errno=1;
				}
				else
				{
					if (DateInMinMax(valeur,vmn,vmx,masque)==false)
					{
						errno=4;
					}
				}
				break;
	
			// Email
			case 'mail':
				var expr = new RegExp("^[a-z0-9_\-]+(\.[a-z0-9_\-]+)*@[a-z0-9\-]*[a-z0-9](\.[a-z0-9\-]*[a-z0-9])*[\.][a-z]{2,3}$","gi");
				if ( !expr.test(valeur) )
				{
					errno=1;
				}
				break;

			// Tlphone Franais
			case 'tel_fr':
				var expr = new RegExp("^([+]33[ ]|0)[1-6,8]{1}[ \.\-]?[0-9]{2}[ ]?[0-9]{2}[ \.\-]?[0-9]{2}[ \.\-]?[0-9]{2}$","gi");
				if ( !expr.test(valeur) )
				{
					errno=1;
				}
				break;

			// Tlphone portable Franais
			case 'telp_fr':
				var expr = new RegExp("^([+]33[ ]|0)6[ \.\-]?[0-9]{2}[ ]?[0-9]{2}[ \.\-]?[0-9]{2}[ \.\-]?[0-9]{2}$","gi");
				if ( !expr.test(valeur) )
				{
					errno=1;
				}
				break;

			// Tlphone international
			case 'tel_int':
				var expr = new RegExp("^([+][0-9]{2,3}[ ]|0)[0-9]{1}[ \.\-]?[0-9]{2}[ ]?[0-9]{2}[ \.\-]?[0-9]{2}[ \.\-]?[0-9]{2}$","gi");
				if ( !expr.test(valeur) )
				{
					errno=1;
				}
				break;

			// Scurit sociale FR
			case 'secu_fr':
				var expr = new RegExp("^[1-2]{1}[ ][0-9]{2}[ ][0-9]{2}[ ][0-9]{1}[A-B0-9]{1}[ ][0-9]{3}[ ][0-9]{3}[ ][0-9]{2}$","g");
				if ( !expr.test(valeur) )
				{
					errno=1;
				}
				else
				{
					if (IsINSEE(valeur)==false)
					{
						errno=1;
					}
				}
				break;

			// Scurit sociale US
			case 'secu_us':
				var expr = new RegExp("^[0-9]{3}[\-][0-9]{2}[\-][0-9]{2}[\-][0-9]{4}$","gi");
				if ( !expr.test(valeur) )
				{
					errno=1;
				}
				break;

			// Code postal FR
			case 'cp_fr':
				var expr = new RegExp("^[0-9]{5}$","gi");
				if ( !expr.test(valeur) )
				{
					errno=1;
				}
				break;

			// Code postal US
			case 'cp_us':
				var expr = new RegExp("^[0-9]{5}(\-[0-9]{4})?$","gi");
				if ( !expr.test(valeur) )
				{
					errno=1;
				}
				break;

			// Adresse IP
			case 'ip':
				var expr = new RegExp("^[0-9]{1,3}[\.][0-9]{1,3}[\.][0-9]{1,3}[\.][0-9]{1,3}$","gi");
				if ( !expr.test(valeur) )
				{
					errno=1;
				}
				else // On vrifie la validit de l'adresse IP saisie
				{
					var tab_ip=valeur.split('.');
					var n=0;
					var tstip=true;
					while ((n<4) && (tstip==true)) 
					{
						if (parseInt(tab_ip[n])>255)
						{
							tstip=false;
						}
						n++;
					}
					if (tstip==false)
					{
						errno=1;
					}
				}
				break;

			// Adresse MAC
			case 'mac':
				var expr = new RegExp("^([0-9a-fA-F][0-9a-fA-F]:){5}([0-9a-fA-F][0-9a-fA-F])$|^([0-9a-fA-F][0-9a-fA-F]-){5}([0-9a-fA-F][0-9a-fA-F])$","gi");
				if ( !expr.test(valeur) )
				{
					errno=1;
				}
				break;

			// Hexadcimal
			case 'hexa':
				if (IsHexa(valeur)==false)
				{
					errno=1;
				}
				else
				{
					if (ValInMinMax(parseInt(valeur),vmn,vmx)==false)
					{
						errno=4;
					}
				}
				break;

			// Non sign
			case 'unsigned':
				if (IsUnsigned(valeur)==false)
				{
					errno=1;
				}
				else
				{
					if (ValInMinMax(parseInt(valeur),vmn,vmx)==false)
					{
						errno=4;
					}
				}
				break;

			// Nombre entier
			case 'entier':
				if (IsInteger(valeur)==false)
				{
					errno=1;
				}
				else
				{
					if (ValInMinMax(parseInt(valeur),vmn,vmx)==false)
					{
						errno=4;
					}
				}
				break;

			// Nombre rel
			case 'reel':
				if (IsReal(valeur)==false)
				{
					errno=1;
				}
				else
				{
					if (ValInMinMax(parseFloat(valeur),vmn,vmx)==false)
					{
						errno=4;
					}
				}
				break;

			// Nombre rel non sign
			case 'reel_ns':
				if (IsRealUnsigned(valeur)==false)
				{
					errno=1;
				}
				else
				{
					if (ValInMinMax(parseFloat(valeur),vmn,vmx)==false)
					{
						errno=4;
					}
				}
				break;

			// Tout texte
			case 'txt':
				break;

			// Alphabtique seulement
			case 'alpha':
				var expr = new RegExp("^[a-z]*$","gi");
				if ( !expr.test(valeur) )
				{
					errno=1;
				}
				break;

			// Alphabtique seulement (minuscules)
			case 'alphamin':
				var expr = new RegExp("^[a-z]*$","g");
				if ( !expr.test(valeur) )
				{
					errno=1;
				}
				break;

			// Alphabtique seulement (majuscules)
			case 'alphamaj':
				var expr = new RegExp("^[A-Z]*$","g");
				if ( !expr.test(valeur) )
				{
					errno=1;
				}
				break;

			// Alphanumrique
			case 'alphanum':
				var expr = new RegExp("^[a-z0-9]*$","gi");
				if ( !expr.test(valeur) )
				{
					errno=1;
				}
				break;

			// Alphanumrique (minuscules seulement)
			case 'alphanummin':
				var expr = new RegExp("^[a-z0-9]*$","g");
				if ( !expr.test(valeur) )
				{
					errno=1;
				}
				break;

			// Alphanumrique (majuscules seulement)
			case 'alphanummaj':
				var expr = new RegExp("^[A-Z0-9]*$","g");
				if ( !expr.test(valeur) )
				{
					errno=1;
				}
				break;

			// Prfixe
			case 'extens':
				if ((valeur.length>=3) && (valeur.length<=4))
				{
					var val1=valeur.charAt(0);
					if (val1=='.')
					{
						var val2=valeur.substr(1,valeur.length-1);
						var expr = new RegExp("^[a-z0-9]*$","g");
						if ( !expr.test(val2) )
						{
							errno=1;
						}
					}
					else
					{
						errno=1;
					}
				}
				else
				{
					errno=1;
				}
				break;

			// Chemin
			case 'chemin':
				var expr = new RegExp("^[a-z0-9_/]*$","gi");
				if ( !expr.test(valeur) )
				{
					errno=1;
				}
				break;

			// Heure
			case 'heure':
				ok=IsHeure(valeur);
				if (ok==false)
				{
					errno=1;
				}
				else
				{
					if (ValInMinMax(ConvertHeureSec(valeur),vmn,vmx)==false)
					{
						errno=4;
					}
				}
				break;

			// Heure hh:mm
			case 'heurehhmm':
				if (IsHeurehhmm(valeur)==false)
				{
					errno=1;
				}
				else
				{
					if (ValInMinMax(ConvertHeurehhmmSec(valeur),vmn,vmx)==false)
					{
						errno=4;
					}
				}
				break;

			// Dure
			case 'duree':
				if (IsDuree(valeur)==false)
				{
					errno=1;
				}
				else
				{
					if (ValInMinMax(ConvertDureeSec(valeur),vmn,vmx)==false)
					{
						errno=4;
					}
				}
				break;
	
			// Dure hh:mm
			case 'duree':
				if (IsDureehhmm(valeur)==false)
				{
					errno=1;
				}
				else
				{
					if (ValInMinMax(ConvertDureehhmmSec(valeur),vmn,vmx)==false)
					{
						errno=4;
					}
				}
				break;
	
			// SIREN Franais
			case 'siren_fr':
				var expr = new RegExp("^[0-9]{3}[ ]?[0-9]{3}[ ]?[0-9]{3}$","gi");
				if ( !expr.test(valeur) )
				{
					errno=1;
				}
				else
				{
					// On "nettoie" la chane puis on vrifie
					var tab_siren=valeur.split(" ");
					var siren=RLtrim(tab_siren.join(""));
					if (IsSiren(siren)==false)
					{
						errno=1;
					}
				}
				break;
	
			// SIRET Franais
			case 'siret_fr':
				var expr = new RegExp("^[0-9]{3}[ ]?[0-9]{3}[ ]?[0-9]{3}[ ]?[0-9]{5}$","gi");
				if ( !expr.test(valeur) )
				{
					errno=1;
				}
				else
				{
					// On "nettoie" la chane puis on vrifie
					var tab_siret=valeur.split(" ");
					var siret=RLtrim(tab_siret.join(""));
					if (IsSiret(siret)==false)
					{
						errno=1;
					}
				}
				break;
	
			// NAF Franais
			case 'naf_fr':
				var expr = new RegExp("^[0-9]{3}[a-z,A-Z]{1}$","gi");
				if ( !expr.test(valeur) )
				{
					errno=1;
				}
				break;
	
			// TVA Franais
			case 'tva_fr':
				var expr = new RegExp("^FR[a-z,A-Z,0-9]{2}[0-9]{9}$","gi");
				if ( !expr.test(valeur) )
				{
					errno=1;
				}
				else
				{
					var siren=valeur.substr(4,9);
					if (IsSiren(siren)==false)
					{
						errno=1;
					}
				}
				break;
	
			// Numro fiscal Franais
			case 'nf_fr':
				var expr = new RegExp("^[0-9]{2}[ ][0-9]{2}[ ][0-9]{3}[ ][0-9]{3}[ ][0-9]{3}[ ][A-Z]{1}$","gi");
				if ( !expr.test(valeur) )
				{
					errno=1;
				}
				break;
	
			// url (avec prfixe http / https / ftp / ftps / sftp / telnet / gopher)
			case 'url_pref':
				var expr = new RegExp("^(http(s?)|ftp(s?)|sftp|telnet|gopher)\://([a-z0-9_\-]+[\:][a-z0-9_\-]+@)?([0-9]{1,3}[\.][0-9]{1,3}[\.][0-9]{1,3}[\.][0-9]{1,3}|[a-z0-9_\-]+[\.][a-z0-9_\-]+[\.][a-z]{2,})([\:][0-9]{2,})?([\/][a-zA-Z0-9\-\.\?\,\'\/\\\+=&%\$#_]*)?$","gi");
				if ( !expr.test(valeur) )
				{
					errno=1;
				}
				break;
	
			// url (sans prfixe)
			case 'url_npref':
				var expr = new RegExp("^([a-z0-9_\-]+[\:][a-z0-9_\-]+@)?([0-9]{1,3}[\.][0-9]{1,3}[\.][0-9]{1,3}[\.][0-9]{1,3}|[a-z0-9_\-]+[\.][a-z0-9_\-]+[\.][a-z]{2,})([\:][0-9]{2,})?([\/][a-zA-Z0-9\-\.\?\,\'\/\\\+=&%\$#_]*)?$","gi");
				if ( !expr.test(valeur) )
				{
					errno=1;
				}
				break;
	
			// mot de passe
			case 'pw':
				if (GivePwQ(valeur)<parseInt(pwq))
				{
					errno=11;
				}
				break;
	
			// RIB Franais
			case 'rib_fr':
				var expr = new RegExp("^[0-9]{5}[ ][0-9]{5}[ ][a-z0-9]{11}[ ][0-9]{2}$","gi");
				if ( !expr.test(valeur) )
				{
					errno=1;
				}
				else
				{
					if (IsRIB(valeur)==false)
					{
						errno=1;
					}
				}
				break;
	
			default:
				break;
		}
	}
	
	return errno;
}

// Routine de contrle du formulaire
function VForm(formulaire,a_champs,pays,lng)
{	
	var txt_pop=''; // Texte du popup d'erreur
	

	if (pays=='')
	{
		pays='fr';
	}
	else
	{
		pays=pays.toLowerCase();
	}
	
	alert('pays '+pays);

	switch(lng)
	{
		case 'en' :
			var tab_messerr = new Array(
			"Required field",
			"Field is not valid",
			"Field length is less than required",
			"Field length is more than required",
			"Field is not inside required values",
			"Bad number of selected options",
			"Bad selected option",
			"The field to compare si not the same type",
			"The 2 input are not the same",
			"The 2 fields to be compared have different structure",
			"Problem on your password field parameters",
			"Problem on your password entry");
			var tab_mpop = new Array(
			"Problem on an enumerating char",
			"One of the fiels doesn't exist or is not an input field",
			"Bad definition of the fiels in the array or in the form");
			var hlp_pw = "Important remind about passwords :\n";
			hlp_pw += "\nThey must include at least an uppercase letter.";
			hlp_pw += "\nThey must include at least a lowercase letter.";
			hlp_pw += "\nThey must include at least one number.";
			hlp_pw += "\nThey must include  least the underscore ('_') character.";
			hlp_pw += "\nThey must include at least one special character ('-,#,@,%,!,$,*,&,<,>').";
			hlp_pw += "\nThey must include at least a special bracket ('[,],{,}').";
			hlp_pw += "\nThey must start with at least one letter.";
			hlp_pw += "\nIt is not recommended to input a space.";
			break;
		default : // Franais
			var tab_messerr = new Array(
			"Champ obligatoire",
			"Saisie non valide",
			"Saisie infrieure  la longueur minimum demande",
			"Saisie suprieure  la longueur maximum demande",
			"Valeur en dehors de la fourchette demande",
			"Mauvaise quantit d'options slectionnes",
			"Mauvaise option slectionne",
			"Le champ  comparer n'est pas du mme type",
			"Les 2 saisies ne sont pas identiques",
			"Structures des 2 champs  comparer diffrentes",
			"Problme sur les paramtres du mot de passe",
			"Problme sur votre saisie du mot de passe");
			var tab_mpop = new Array(
			"Problme sur le caractre d'numration",
			"Un des champs n'existe pas ou n'est pas un champ de saisie",
			"Mauvaise dfinition des champs dans le tableau ou le formulaire");
			var hlp_pw = "Rappel important sur les mots de passe :\n";
			hlp_pw += "\nIl doit y avoir au moins une majuscule.";
			hlp_pw += "\nIl doit y avoir au moins une minuscule.";
			hlp_pw += "\nIl doit y avoir au moins un chiffre.";
			hlp_pw += "\nIl doit y avoir au moins le caractre soulign ('_').";
			hlp_pw += "\nIl doit y avoir au moins un caractre spcial ('-,#,@,%,!,$,*,&,<,>').";
			hlp_pw += "\nIl doit y avoir au moins une parenthse spciale ('[,],{,}').";
			hlp_pw += "\nIl vaut mieux commencer par une lettre.";
			hlp_pw += "\nIl n'est pas recommand d'entrer des espaces.";
			break;
	}
	
	if (a_champs)
	{
		for (var no_champ=0; no_champ<a_champs.length; no_champ++)
		{
			var long_saisie=0;
			// Les champs tant spars par des ";", on clate la chane
			var tab_prm=RLtrim(a_champs[no_champ]).split(";");
			var	tab_prmchamp=new Array();
			// On contrle tous les paramtres un par un
			for (var no_prm=0; no_prm<tab_prm.length; no_prm++ )
			{
				// Les paramtres tant de la forme "nom_prm : valeur", on clate la chane
				tab_typeprm=RLtrim(tab_prm[no_prm]).split(":");
				
				if ((tab_typeprm.length)>=2)
				{
					// On reconstruit le paramtre (par exemple s'il est de la format hh:mm:ss, vform l'aura clat en tableau)
					var str_prm='';
					for (var idx=1; idx<tab_typeprm.length; idx++)
					{
						str_prm+=RLtrim(tab_typeprm[idx])+':';
					}
					
					// On limine le dernier ':'
					str_prm=str_prm.substr(0,str_prm.length-1);
					
					// On cre le paramtre final
					tab_prmchamp[RLtrim(tab_typeprm[0].toLowerCase())]=str_prm;
				}
			}

			var ok=true;
			
			// Vrifie le code pays du formulaire
			switch (pays)
			{
				case 'fr':
				case 'us':
					break;
				default :
					ok=false;
					break;
			}
	
			if (ok==true)
			{
				// Contrle du nom
				if (tab_prmchamp["nom"])
				{
					var nom_champ=RLtrim(tab_prmchamp["nom"]);
					var champ=document.getElementsByName(nom_champ);
	
					if (champ && champ.length>0) 
					{
						// Contrle du champ de comparaison (s'il existe...sinon, on ne compare rien)
						if (tab_prmchamp["comp"])
						{
							var nom_champcomp=RLtrim(tab_prmchamp["comp"]);
							var champcomp=document.getElementsByName(nom_champcomp);
			
							if (!champcomp || champcomp.length<=0) 
							{
								delete(tab_prmchamp["comp"]);
							}
							else
							{
								var type_champcomp=champcomp[0].type;
								var val_champcomp=champcomp[0].value;
							}
						}
					
						var type_champ=champ[0].type;
						var val_champ=champ[0].value;
	
						// On contrle que les paramtres "minimum" existent, sinon valeur par dfaut
			
						// Champ requis ?
						if ( !tab_prmchamp["req"] )
						{
							tab_prmchamp["req"]=false;
						}
						else
						{
							if ((tab_prmchamp["req"]=="Y") || (tab_prmchamp["req"]=="y") || (tab_prmchamp["req"]=="O") || (tab_prmchamp["req"]=="o"))
							{
								tab_prmchamp["req"]=true;
							}
							else
							{
								tab_prmchamp["req"]=false;
							}
						}
			
						// Descriptif du champ
						if ( !tab_prmchamp["txt"] )
						{	
							tab_prmchamp["txt"]="Champ "+champ[0].name;
						}
	
						// Contrle du cracatre d'numration (si existe)
						var carenumok=true;
						var avecenum=false;
		
						if (tab_prmchamp["carenum"])
						{
							var carenum=RLtrim(tab_prmchamp["carenum"]);
							
							if (carenum.length!=1)
							{
								delete(tab_prmchamp["carenum"]);
								carenumok=false;
							}
							else
							{
								switch (type_champ.toLowerCase())
								{
								// Dans ces 4 cas, il est inutile de dfinir une numration
								case 'select-one':
								case 'select-multiple':
								case 'radio':
								case 'checkbox':
									carenum='';
									avecenum=false;
									delete(tab_prmchamp["carenum"]);
									break;
								default:
									var tab_enum=RLtrim(val_champ).split(carenum);
									avecenum=true;
									break;
								}
							}
							
						}
						
						if (carenumok==true)
						{
							var errno=-1;
							var ok=true;
							
							// Test si champ obligatoire
							// S'il est vide, ce n'est mme pas la peine de tester le reste
							if (tab_prmchamp["req"]==true) // le champ est obligatoire
							{
								switch (type_champ.toLowerCase())
								{
									case 'text':
									case 'textarea':
									case 'password':
										if (avecenum==true)
										{
											var no_enum=0;
											while ((no_enum<tab_enum.length) && (errno==-1))
											{
												if (ChampEstVide(tab_enum[no_enum]))
												{
													errno=0;
												}
												no_enum++;
											}
										}
										else
										{
											if (ChampEstVide(val_champ))
											{
												errno=0;
											}
										}
										break;
									case 'select-one':
										var sel_champ=champ[0].selectedIndex;
										if (parseInt(sel_champ)<0)
										{
											errno=0;
										}
										break;
									case 'select-multiple':
										if (NbElementsSel(champ)==0)
										{
											errno=0;
										}
										break;
									case 'radio':
									case 'checkbox':
										if (NbElementsChk(champ)==0)
										{
											errno=0;
										}
										break;
									default:
										break;
								}
							}
						
							if (errno>=0)
							{
								ok=false;
							}
	
							// Le test" champ requis" est pass, on vrifie si c'est un mot de passe
							if (ok==true)
							{
								// Format
								if (!tab_prmchamp["format"])
								{
									tab_prmchamp["format"]="";
								}
		
								// Contrle si mot de passe
								if (tab_prmchamp["format"]=="pw")
								{
									if (tab_prmchamp["pwq"])
									{
										if ((parseInt(tab_prmchamp["pwq"])<0) || (parseInt(tab_prmchamp["pwq"])>8))
										{
											errno=10;
										}
									}
									else
									{
										errno=10;
									}
								}
							}
									
							if (errno>=0)
							{
								ok=false;
							}
	
							// Le test "mot de passe" est pass, on vrifie maintenant "longueur mini" et "longueur maxi"
							if (ok==true)
							{
								// Longueur Minimum (pour liste : nb minimum de slectionns)
								if (tab_prmchamp["lmn"])
								{
									// Dfini : on vrifie si c'est bien un entier non sign
									if (IsUnsigned(tab_prmchamp["lmn"]))  // Oui, on converti en entier
									{
										tab_prmchamp["lmn"]=parseInt(tab_prmchamp["lmn"]);
									}
									else // Non, on affecte une longueur mini (puisque d'un minimum a t demand, mais qu'il est faux)
									{
										tab_prmchamp["lmn"]=0;
									}
									
									// On contrle la longueur mini de la saisie
									switch (type_champ.toLowerCase())
									{
										case 'text':
										case 'textarea':
										case 'password':
											if (avecenum==true)
											{
												var no_enum=0;
												while ((no_enum<tab_enum.length) && (errno==-1))
												{
													if (ChampEstVide(tab_enum[no_enum]))
													{
														long_saisie=0;
													}
													else
													{
														long_saisie=parseInt(tab_enum[no_enum].length);
													}
													if (long_saisie<tab_prmchamp["lmn"])
													{
														errno=2;
													}
													no_enum++;
												}
											}
											else
											{
												if (ChampEstVide(val_champ))
												{
													long_saisie=0;
												}
												else
												{
													long_saisie=parseInt(val_champ.length);
												}
												if (long_saisie<tab_prmchamp["lmn"])
												{
													errno=2;
												}
											}
											break;
										case 'select-multiple':
											if (NbElementsSel(champ)<tab_prmchamp["lmn"])
											{
												errno=2;
											}
											break;
										case 'checkbox':
											if (NbElementsChk(champ)<tab_prmchamp["lmn"])
											{
												errno=2;
											}
											break;
										default:
											break;
									}
								}
							
								if (errno>=0)
								{
									ok=false;
								}
			
								// Le test" champ requis" est pass, on vrifie maintenant "longueur mini" et "longueur maxi"
								if (ok==true)
								{
									// Longueur Maximum (pour liste : nb minimum de slectionns)
									if (tab_prmchamp["lmx"])
									{
										// Dfini : on vrifie si c'est bien un entier non sign
										if (IsUnsigned(tab_prmchamp["lmx"])) // Oui, on converti en entier
										{
											tab_prmchamp["lmx"]=parseInt(tab_prmchamp["lmx"]);
										}
										else // Non, on affecte une longueur maxi (puisque d'un maximum a t demand, mais qu'il est faux)
										{
											switch (type_champ.toLowerCase())
											{
												case 'text':
												case 'textarea':
												case 'password':
													max_length=Number(champ.maxlength);
													if (max_length)
													{
														tab_prmchamp["lmx"]=max_length;
													}
													else
													{
														tab_prmchamp["lmx"]=0;
													}
													break;
												case 'select-one':
												case 'select-multiple':
													// Le maxi est le nombre maximum d'lments de la liste
													tab_prmchamp["lmx"]=champ[0].options.length;
													break;
												case 'radio':
												case 'checkbox':
													// Le maxi est le nombre maximum d'lments  cocher
													tab_prmchamp["lmx"]=champ.length;
												default:
													break;
											}
										}
										
										// On contrle la longueur maxi de la saisie
										switch (type_champ.toLowerCase())
										{
											case 'text':
											case 'textarea':
											case 'password':
												if (avecenum==true)
												{
													var no_enum=0;
													while ((no_enum<tab_enum.length) && (errno==-1))
													{
														if (ChampEstVide(tab_enum[no_enum]))
														{
															long_saisie=0;
														}
														else
														{
															long_saisie=parseInt(tab_enum[no_enum].length);
														}
														if (long_saisie>tab_prmchamp["lmx"])
														{
															errno=3;
														}
														no_enum++;
													}
												}
												else
												{
													if (ChampEstVide(val_champ))
													{
														long_saisie=0;
													}
													else
													{
														long_saisie=parseInt(val_champ.length);
													}
													if (long_saisie>tab_prmchamp["lmx"])
													{
														errno=3;
													}
												}
												break;
											case 'select-multiple':
												if (NbElementsSel(champ)>tab_prmchamp["lmx"])
												{
													errno=3;
												}
												break;
											case 'checkbox':
												if (NbElementsChk(champ)>tab_prmchamp["lmx"])
												{
													errno=3;
												}
												break;
											default:
												break;
										}
									}
								}
			
								if (errno>=0)
								{
									ok=false;
								}
			
								// Si les paramtres "longueur de champ" sont passs, on vrifie maintenant le paramtre
								// "valeur mini" et on le modifie si besoin
								if (ok==true)
								{
									// Valeur Minimum (vrifie et modifie que si paramtre)
									if (tab_prmchamp["vmn"])
									{
										switch (tab_prmchamp["format"])
										{
											case 'date':
												// Dfini : on vrifie si c'est bien une date valable au format demand
												if (IsDate(tab_prmchamp["vmn"],tab_prmchamp["masque"])) // Oui
												{
													break;
												}
												else // Non
												{
													delete(tab_prmchamp["vmn"]);
												}
												break;
											case 'hexa':
												// Dfini : on vrifie si c'est bien un hxadcimal
												if (IsHexa(tab_prmchamp["vmn"])) // Oui
												{
													tab_prmchamp["vmn"]=parseInt(tab_prmchamp["vmn"]);
												}
												else // Non
												{
													delete(tab_prmchamp["vmn"]);
												}
												break;
											case 'unsigned':
												// Dfini : on vrifie si c'est bien un non sign
												if (IsUnsigned(tab_prmchamp["vmn"])) // Oui
												{
													tab_prmchamp["vmn"]=parseInt(tab_prmchamp["vmn"]);
												}
												else // Non
												{
													delete(tab_prmchamp["vmn"]);
												}
												break;
											case 'entier':
												// Dfini : on vrifie si c'est bien un entier
												if (IsInteger(tab_prmchamp["vmn"])) // Oui
												{
													tab_prmchamp["vmn"]=parseInt(tab_prmchamp["vmn"]);
												}
												else // Non
												{
													delete(tab_prmchamp["vmn"]);
												}
												break;
											case 'reel':
												// Dfini : on vrifie si c'est bien un rel
												if (IsReal(tab_prmchamp["vmn"])) // Oui
												{
													tab_prmchamp["vmn"]=parseFloat(tab_prmchamp["vmn"]);
												}
												else // Non
												{
													delete(tab_prmchamp["vmn"]);
												}
												break;
											case 'reel_ns':
												// Dfini : on vrifie si c'est bien un rel non sign
												if (IsRealUnsigned(tab_prmchamp["vmn"])) // Oui
												{
													tab_prmchamp["vmn"]=parseFloat(tab_prmchamp["vmn"]);
												}
												else // Non
												{
													delete(tab_prmchamp["vmn"]);
												}
												break;
											case 'heure':
												// Dfini : on vrifie si c'est bien une heure
												if (IsHeure(tab_prmchamp["vmn"])) // Oui
												{
													tab_prmchamp["vmn"]=ConvertHeureSec(tab_prmchamp["vmn"]);
												}
												else // Non
												{
													delete(tab_prmchamp["vmn"]);
												}
												break;
											case 'heurehhmm':
												// Dfini : on vrifie si c'est bien une heure
												if (IsHeurehhmm(tab_prmchamp["vmn"])) // Oui
												{
													tab_prmchamp["vmn"]=ConvertHeurehhmmSec(tab_prmchamp["vmn"]);
												}
												else // Non
												{
													delete(tab_prmchamp["vmn"]);
												}
												break;
											case 'duree':
												// Dfini : on vrifie si c'est bien une heure
												if (IsDuree(tab_prmchamp["vmn"])) // Oui
												{
													tab_prmchamp["vmn"]=ConvertDureeSec(tab_prmchamp["vmn"]);
												}
												else // Non
												{
													delete(tab_prmchamp["vmn"]);
												}
												break;
											case 'dureehhmm':
												// Dfini : on vrifie si c'est bien une heure
												if (IsDureehhmm(tab_prmchamp["vmn"])) // Oui
												{
													tab_prmchamp["vmn"]=ConvertDureehhmmSec(tab_prmchamp["vmn"]);
												}
												else // Non
												{
													delete(tab_prmchamp["vmn"]);
												}
												break;
											case 'liste':
											case 'listem':
											case'radio':
											case 'checkbox':
												// Dfini : on vrifie si c'est bien un entier
												if (IsUnsigned(tab_prmchamp["vmn"])) // Oui
												{
													tab_prmchamp["vmn"]=parseInt(tab_prmchamp["vmn"]);
												}
												else // Non
												{
													tab_prmchamp["vmn"]=0; // Mini = 1er lment de la liste
												}
												break;
											default:
												delete(tab_prmchamp["vmn"]);
												break;
										}
									}
								}
								
								if (errno>=0)
								{
									ok=false;
								}
			
								// On vrifie maintenant le paramtre "valeur maxi" et on le modifie si besoin
								if (ok==true)
								{
									// Valeur Maximum (vrifie et modifie que si paramtre)
									if (tab_prmchamp["vmx"])
									{
										switch (tab_prmchamp["format"] )
										{
											case 'date':
												// Dfini : on vrifie si c'est bien une date valable au format demand
												if (IsDate(tab_prmchamp["vmx"],tab_prmchamp["masque"])) // Oui
												{
													break;
												}
												else // Non
												{
													delete(tab_prmchamp["vmx"]);
												}
												break;
											case 'hexa':
												// Dfini : on vrifie si c'est bien un hxadcimal
												if (IsHexa(tab_prmchamp["vmx"])) // Oui
												{
													tab_prmchamp["vmx"]=parseInt(tab_prmchamp["vmx"]);
												}
												else // Non
												{
													delete(tab_prmchamp["vmn"]);
												}
												break;
											case 'unsigned':
												// Dfini : on vrifie si c'est bien un non sign
												if (IsUnsigned(tab_prmchamp["vmx"])) // Oui
												{
													tab_prmchamp["vmx"]=parseInt(tab_prmchamp["vmx"]);
												}
												else // Non
												{
													delete(tab_prmchamp["vmx"]);
												}
												break;
											case 'entier':
												// Dfini : on vrifie si c'est bien un entier
												if (IsInteger(tab_prmchamp["vmx"])) // Oui
												{
													tab_prmchamp["vmx"]=parseInt(tab_prmchamp["vmx"]);
												}
												else // Non
												{
													delete(tab_prmchamp["vmx"]);
												}
												break;
											case 'reel':
												// Dfini : on vrifie si c'est bien un rel
												if (IsReal(tab_prmchamp["vmx"])) // Oui
												{
													tab_prmchamp["vmx"]=parseFloat(tab_prmchamp["vmx"]);
												}
												else // Non
												{
													delete(tab_prmchamp["vmx"]);
												}
												break;
											case 'reel_ns':
												// Dfini : on vrifie si c'est bien un rel non sign
												if (IsRealUnsigned(tab_prmchamp["vmx"])) // Oui
												{
													tab_prmchamp["vmx"]=parseFloat(tab_prmchamp["vmx"]);
												}
												else // Non
												{
													delete(tab_prmchamp["vmx"]);
												}
												break;
											case 'heure':
												// Dfini : on vrifie si c'est bien une heure
												if (IsHeure(tab_prmchamp["vmx"])) // Oui
												{
													tab_prmchamp["vmx"]=ConvertHeureSec(tab_prmchamp["vmx"]);
												}
												else // Non
												{
													delete(tab_prmchamp["vmx"]);
												}
												break;
											case 'heurehhmm':
												// Dfini : on vrifie si c'est bien une heure
												if (IsHeurehhmm(tab_prmchamp["vmx"])) // Oui
												{
													tab_prmchamp["vmx"]=ConvertHeurehhmmSec(tab_prmchamp["vmx"]);
												}
												else // Non
												{
													delete(tab_prmchamp["vmx"]);
												}
												break;
											case 'duree':
												// Dfini : on vrifie si c'est bien une heure
												if (IsDuree(tab_prmchamp["vmx"])) // Oui
												{
													tab_prmchamp["vmx"]=ConvertDureeSec(tab_prmchamp["vmx"]);
												}
												else // Non
												{
													delete(tab_prmchamp["vmx"]);
												}
												break;
											case 'dureehhmm':
												// Dfini : on vrifie si c'est bien une heure
												if (IsDureehhmm(tab_prmchamp["vmx"])) // Oui
												{
													tab_prmchamp["vmx"]=ConvertDureehhmmSec(tab_prmchamp["vmx"]);
												}
												else // Non
												{
													delete(tab_prmchamp["vmx"]);
												}
												break;
											case 'liste':
											case 'listem':
											case 'radio':
											case 'checkbox':
												// Dfini : on vrifie si c'est bien un entier
												if (IsUnsigned(tab_prmchamp["vmx"])) // Oui
												{
													tab_prmchamp["vmx"]=parseInt(tab_prmchamp["vmx"]);
													if (tab_prmchamp["vmx"]>champ.length-1)
													{
														tab_prmchamp["vmx"]=champ.length-1; // Maxi = dernier lmnt de la liste
													}
												}
												else // Non
												{
													tab_prmchamp["vmx"]=champ.length-1; // Maxi = dernier lmnt de la liste
												}
												break;
											default:
												delete(tab_prmchamp["vmx"]);
												break;
										}
									}
								}
								
								if (errno>=0)
								{
									ok=false;
								}
											
								// Les paramtres de champs sont ok, 
								// On analyse les diffrents paramtres du type dclar en fonction du type de champ
								// uniquement si le champ est rempli
								if (ok==true)
								{
									switch (type_champ.toLowerCase())
									{
										case 'radio':
											var prem_checked=-1;
											var n=0;
											while ((n<champ.length) && (prem_checked<0)) 
											{
												if (champ[n].checked)
												{	
													if (prem_checked==-1)
													{
														prem_checked=n;
													}
												}
												n++;
											}
											// On ne teste que si au moins un bouton est choch
											if (prem_checked!=-1)
											{
												// On vrifie si la valeur de case coche est bien dans la fourchette mini/maxi
												if (ValInMinMax(prem_checked,tab_prmchamp["vmn"],tab_prmchamp["vmx"])==false)
												{
													errno=6;
												}
											}
											break;
									
										case 'checkbox':
											// Nombre de cases coches
											var prem_checked=-1;
											var nbChecked=0;
											for (var nb=0; nb<champ.length; nb++)
											{
												if (champ[nb].checked)
												{	
													if (prem_checked==-1)
													{
														prem_checked=nb;
													}
													nbChecked++;
												}
											}
											// On ne teste que si au moins une case est coche
											if (nbChecked>0)
											{
												// On vrifie si la valeur de la ligne slectionne est bien dans la fourchette
												if (ValInMinMax(prem_checked,tab_prmchamp["vmn"],tab_prmchamp["vmx"])==false)
												{
													errno=6;
												}
												else // On vrifie si le nombre de lignes slectionnes est bien dans la fourchette
												{
													if (ValInMinMax(nbChecked,tab_prmchamp["lmn"],tab_prmchamp["lmx"])==false)
													{
														errno=5;
													}
												}
											}
											break;
									
										case 'select-one':
											var sel_champ=champ[0].selectedIndex;
											if (ValInMinMax(parseInt(sel_champ),tab_prmchamp["vmn"],tab_prmchamp["vmx"])==false)
											{
												errno=6;
											}
											break;
			
										case 'select-multiple':
											// Nombre de slectionns
											var prem_select=-1;
											var nbSelected=0;
											for (var nb=0; nb<champ[0].options.length; nb++)
											{
												if (champ[0].options[nb].selected)
												{
													if (prem_select==-1)
													{
														prem_select=nb;
													}
													nbSelected++;
												}
											}
											// On vrifie si la valeur de la ligne slectionne est bien dans la fourchette
											if (ValInMinMax(prem_select,tab_prmchamp["vmn"],tab_prmchamp["vmx"])==false)
											{
												errno=6;
											}
											
											// On vrifie si le nombre de lignes slectionnes est bien dans la fourchette
											if (ValInMinMax(nbSelected,tab_prmchamp["lmn"],tab_prmchamp["lmx"])==false)
											{
												errno=5;
											}
											break;
		
										case 'text':
										case 'textarea':
										case 'password':
											if (avecenum==true)
											{
												var no_enum=0;
												while ((no_enum<tab_enum.length) && (errno==-1))
												{
													errno=valide_champ(pays,tab_enum[no_enum],tab_prmchamp["format"],tab_prmchamp["masque"],tab_prmchamp["vmn"],tab_prmchamp["vmx"],tab_prmchamp["pwq"]);
													no_enum++;
												}
											}
											else
											{
												errno=valide_champ(pays,val_champ,tab_prmchamp["format"],tab_prmchamp["masque"],tab_prmchamp["vmn"],tab_prmchamp["vmx"],tab_prmchamp["pwq"]);
											}
											break;
								
										default:
											break;
									}
								}
			
								if (errno>=0)
								{
									ok=false;
								}
						
								// On vrifie maintenant s'il y a un champ de comparaison
								if (ok==true)
								{
									if (tab_prmchamp["comp"])
									{
										if ((type_champ.toLowerCase())!=(type_champcomp.toLowerCase()))
										{
											errno=7;
										}
										else
										{
											switch (type_champ.toLowerCase())
											{
												case 'radio':
												case 'checkbox':
													// On vrifie la longueur des champs
													if (champ.length==champcomp.length)
													{
														var tstok=true;
														var n=0;
														while ((n<champ.length) && (tstok)) 
														{
															// On vrifie la valeur des champs
															if (champ[n].value==champcomp[n].value)
															{
																// On vrifie s'il ont un tat "coch"/"non coch" identique
																if (champ[n].checked!=champcomp[n].checked)
																{
																	errno=8;
																	tstok=false;
																}
															}
															else
															{
																errno=9;
																tstok=false;
															}
															n++;
														}
													}
													else
													{
														errno=9;
													}
													break;
												case 'text':
												case 'textarea':
												case 'password':
													if (val_champ!=val_champcomp)
													{
														errno=8;
													}
													break;
												case 'select-one':
													// On vrifie la longueur des champs
													if (champ[0].options.length==champcomp[0].options.length)
													{
														if (champ[0].selectedIndex!=champcomp[0].selectedIndex)
														{
															errno=8;
														}
													}
													else
													{
														errno=9;
													}
													break;
												case 'select-multiple':
													// On vrifie la longueur des champs
													if (champ[0].options.length==champcomp[0].options.length)
													{
														var tstok=true;
														var n=0;
														while ((n<champ[0].options.length) && (tstok)) 
														{
															// On vrifie la valeur des champs
															if (champ[0].options[n].value==champcomp[0].options[n].value)
															{
																// On vrifie s'il ont un tat "coch"/"non coch" identique
																if (champ[0].options[n].selected!=champcomp[0].options[n].selected)
																{
																	errno=8;
																	tstok=false;
																}
															}
															else
															{
																errno=9;
																tstok=false;
															}
															n++;
														}
													}
													else
													{
														errno=9;
													}
													break;
												default:
													break;
											}
										}
									}
								}
							}
							
							// Construction du message d'erreur
							if (errno>=0)
							{
								// Si style dfini pour l'erreur on l'affiche
								if (tab_prmchamp["stbad"])
								{
									champ[0].className=tab_prmchamp["stbad"]; 
									if (tab_prmchamp["comp"])
									{
										champcomp[0].className=tab_prmchamp["stbad"];
									}
								}
								txt_pop+=ConvertAccents(tab_prmchamp["txt"])+' :\n --> '+ConvertAccents(tab_messerr[errno]);
								if (avecenum==true)
								{
									txt_pop+=ConvertAccents(' sur une des numrations');
								}
								if (errno==11)
								{
									switch(lng)
									{
										case 'en' :
											txt_pop+='\n\nVotre Your password has a quality of '+GivePwQ(val_champ)+' for 8 possible.';
											break;
										case 'en' :
											txt_pop+='\n\nVotre mot de passe possde un indice de qualit de '+GivePwQ(val_champ)+' sur 8 possibles.';
											break;
									}
									txt_pop+='\n\n'+hlp_pw;
								}
								txt_pop+='\n';
							}
							else
							{
								// Si style dfini pour champ ok on l'affiche
								champ[0].className=tab_prmchamp["stok"];
								if (tab_prmchamp["comp"])
								{
									champcomp[0].className=tab_prmchamp["stok"];
								}
							}
						}
						else
						{
							txt_pop=tab_mpop[0];
							alert(ConvertAccents(txt_pop));
							return false;
						}
						
					}
					else
					{
						txt_pop=tab_mpop[1];
						alert(ConvertAccents(txt_pop));
						return false;
					}
				}
				else
				{
					txt_pop=tab_mpop[2];
					alert(ConvertAccents(txt_pop));
					return false;
				}
			}
			else
			{
				switch (lng)
				{
					case 'en' :
						txt_pop="Unknown country code";
						break;
					default :
						txt_pop="Code pays non gr";
						break;
				}
				alert(ConvertAccents(txt_pop));
				return false;
			}
		}
	}
	else
	{
		switch (lng)
		{
			case 'en' :
				txt_pop="Parameters array not defined";
				break;
			default :
				txt_pop="Tableau de paramtrage non dfini";
				break;
		}
		txt_pop=ConvertAccents(txt_pop);
	}
	
	// Si texte pop dfini, on l'affiche
	if (txt_pop.length>0)
	{	
		alert(txt_pop);
		return false;
	}
	else
	{
		return true;
	}	
}
